#include <cstdint>
#include <iostream>

void print_char(auto c) {
	std::cout << sizeof(c) << " bytes: "
	          << static_cast<std::int64_t>(c) << '\n';
}

int main() {
	auto c = 'x';
	auto utf8 = u8'x';
	auto utf16 = u'x';
	auto utf32 = U'x';
	auto w = L'x';

	print_char(c);
	print_char(utf8);
	print_char(utf16);
	print_char(utf32);
	print_char(w);

	std::cout << "---\n";

	// utf8 = u8'č';  // error
	utf16 = u'č';
	utf32 = U'č';
	w = L'č';

	print_char(utf16);
	print_char(utf32);
	print_char(w);

	std::cout << "---\n";

	// utf16 = u'💰';  // error
	utf32 = U'💰';
	w = L'💰';  // error on Windows, OK on Linux

	print_char(utf32);
	print_char(w);
}
