#include <algorithm>
#include <iostream>
#include <span>
#include <vector>

void print_span(std::span<const int> s) {
	auto sep = "{ ";
	for (int x : s) {
		std::cout << sep << x;
		sep = ", ";
	}
	std::cout << (s.empty() ? "{}" : " }") << '\n';
}

bool binary_search(std::span<const int> s, int value) {
	// every Python beginner's dream
	if (s.empty())
		return false;
	auto mid = s.size() / 2;
	if (s[mid] < value)          // s[:mid]
		return binary_search(s.subspan(0, mid), value);
	if (s[mid] > value)          // s[mid + 1:]
		return binary_search(s.subspan(mid + 1), value);
	// ==
	return true;
}

int main() {
	namespace ranges = std::ranges;
	std::vector vec = { 3, 1, 4, 1, 5, 9, 2, 6, 5, 3 };
	std::span s = { vec.begin() + 1, vec.end() - 1 };

	ranges::sort(s);
	print_span(vec);

	std::cout << binary_search(s, 5) << ' '
	          << binary_search(s, 3) << '\n';
}
