#include <iostream>
#include <string>

void print_string(const std::string& s) {
	std::cout << "std::string of size " << s.size() << ": \""
	          << s << "\"\n";
}

void tell(const char*) {
	std::cout << "C-like string\n";
}
void tell(const std::string&) {
	std::cout << "std::string\n";
}

int main() {
	std::string s;
	print_string(s);

	// this is OK and always 0
	std::cout << static_cast<int>(s[s.size()]) << '\n';

	// s = "Hello," + " world!"; // this doesn't work
	s = "Hello, world!";
	print_string(s);

	s = "Ahoj, ";
	s += "světe!";
	print_string(s);

	s[5] = '_';
	print_string(s);

	s[5] = '\0';
	print_string(s);

	print_string("Why does this work?");

	s.clear();

	using namespace std::string_literals;

	auto ptr = "This is C-like.";
	auto str = "This is std::string."s; // <- notice the suffix
	tell(ptr);
	tell(str);

	str = "Will not stop on \0, see?"s;
	std::cout << str << '\n';
}
