#include <iostream>
#include <string>

void show_pos(const std::string& s, std::size_t pos) {
	std::cout << s << '\n';
	while (pos --> 0) std::cout << ' ';
	std::cout << "^\n";
}

int main() {
	std::string s = "How many spaces are here?";
	std::cout << "Finding spaces:\n";
	std::size_t pos = 0;
	while ((pos = s.find(' ', pos)) != std::string::npos) {
		show_pos(s, pos);
		++pos;
	}

	std::cout << "Finding \"spaces\":\n";
	pos = s.find("spaces");
	show_pos(s, pos);

	auto sub = s.substr(pos, 6);
	s[pos] = 'S';

	std::cout << sub << '\n';
	std::cout << s << '\n';

	s.replace(pos, 6, "' 's");
	std::cout << s << '\n';
}
