#include <iostream>
#include <string>
#include <string_view>

void print_word(std::string_view word) {
	std::cout << "Word: " << word << '\n';
}

void parse_words(std::string_view text) {
	// no new std::strings are created here
	auto start = text.find_first_not_of(' ');
	while (start != std::string_view::npos) {
		auto end = text.find_first_of(' ', start);
		print_word(text.substr(start, end - start));
		start = text.find_first_not_of(' ', end);
	}
}

std::string_view trim(std::string_view text) {
	auto start = text.find_first_not_of(' ');
	if (start == std::string_view::npos)
		return {};
	text.remove_prefix(start);
	auto end = text.find_last_not_of(' ');
	text.remove_suffix(text.size() - end - 1);
	return text;
}

int main() {
	parse_words("There are some words here.");

	std::string s = "   some words here    ";

	auto trimmed = trim(s);
	std::cout << ">>" << trimmed << "<<\n";

	s[4] = 'a';  // note: this doesn't invalidate references et al.
	std::cout << ">>" << trimmed << "<<\n";

	for (char c : trimmed)
		std::cout << '.' << c;
	std::cout << ".\n";
}
