#include <cstdint>
#include <iostream>

void print_string(const auto* ptr) {
	std::cout << "code unit size: " << sizeof(*ptr) << '\n';
	int i = 0;
	do {
		std::cout << i++ << ". code unit: "
		          << static_cast<std::int64_t>(*ptr) << '\n';
	} while (*ptr++ != 0);
	std::cout << "---\n";
}

int main() {
	print_string("čau 💙");
	print_string(u8"čau 💙");
	print_string(u"čau 💙");
	print_string(U"čau 💙");
	print_string(L"čau 💙");

	auto noel = "noe\u0308l";
	std::cout << noel << "\n---\n";
	print_string(noel);
	print_string(U"noe\u0308l");
	print_string(U"noël");
}
