#include <codecvt>
#include <cstdint>
#include <iostream>
#include <locale>
#include <string>
#include <string_view>

std::u32string to_utf32(std::string_view s) {
	std::wstring_convert<std::codecvt_utf8<char32_t>,
	                     char32_t> conv;
	auto* start = s.data();
	return conv.from_bytes(start, start + s.size());
}

std::string from_utf32(std::u32string_view s) {
	std::wstring_convert<std::codecvt_utf8<char32_t>,
	                     char32_t> conv;
	auto* start = s.data();
	return conv.to_bytes(start, start + s.size());
}

int main() {
	std::u32string u32 = U"čau 💙";
	auto s = from_utf32(u32);
	std::cout << s << '\n';

	std::getline(std::cin, s);

	u32 = to_utf32(s);
	for (auto c : u32) {
		auto letter = from_utf32({ &c, 1 });
		std::cout << "codepoint no. " << static_cast<std::int64_t>(c)
		          << ": " << letter << '\n';
	}
}
